<?php

class PageUserProfile extends Page
{
	function SendMail()
	{
		global $Config, $User;
	
		$Output = '';
		if(array_key_exists('text', $_POST))
		if($User->Licence(LICENCE_ADMIN))
		{
			$Text = $_POST['text'];
			$Email = $_POST['email'];
			$Subject = $_POST['subject'];
			$Output = 'Email: <strong>'.$Email.'</strong><br />'.
					'Předmět: <strong>'.$Subject.'</strong><br />'.
					'Text: <strong>'.$Text.'</strong><br />';
	
			if(@mail($Email, $Subject, $Text, 'From: '.$Config['Web']['AdminEmail'].'\nReply-To: '.$Config['Web']['AdminEmail'].'\nX-Mailer: PHP/'))
			{
				$Output .= ShowMessage('Zpráva byla odeslána.');
			}
			else $Output .= ShowMessage('Nepodařilo se odesat E-mail.', MESSAGE_CRITICAL);
		} else $Output .= ShowMessage('Nemáte oprávnění', MESSAGE_CRITICAL);
		return($Output);
	}
	
	function ExportList()
	{
		$Output = '';
		$Filter = ' WHERE `Export`.`User` = '.($_GET['user'] * 1);
		$DbResult = $this->System->Database->query('SELECT COUNT(*) FROM `Export` '.$Filter);
		$DbRow = $DbResult->fetch_row();
		$PageList = GetPageList($DbRow[0]);
	
		$Output .= '<h3>Exporty</h3>'.
				$PageList['Output'];
	
		$TableColumns = array(
				array('Name' => 'TimeCreate', 'Title' => 'Čas vytvoření'),
				array('Name' => 'Title', 'Title' => 'Označení'),
				//  array('Name' => 'UserCount', 'Title' => 'Vybraných překladatelů'),
				//  array('Name' => 'GroupCount', 'Title' => 'Překladových skupin'),
				array('Name' => 'OutputType', 'Title' => 'Typ výstupu'),
				array('Name' => 'ClientVersion', 'Title' => 'Verze klienta'),
				array('Name' => 'UsedCount', 'Title' => 'Prohlédnutí výstupu'),
				array('Name' => '', 'Title' => 'Akce'),
		);
		$Order = GetOrderTableHeader($TableColumns, 'TimeCreate', 1);
		$Output .= '<table class="BaseTable">'.
				$Order['Output'];
	
		$DbResult = $this->System->Database->query('SELECT `User`.`Name` AS `UserName`, `Export`.`Id`, `Export`.`TimeCreate`, `Export`.`Title`, `Export`.`User`, `Export`.`UsedCount`, (SELECT Version FROM `ClientVersion` WHERE `ClientVersion`.`Id`=`Export`.`ClientVersion`) AS `ClientVersion`,(SELECT Name FROM `ExportOutputType` WHERE `ExportOutputType`.`Id`=`Export`.`OutputType`) AS `OutputType`, (SELECT COUNT(*) FROM `ExportGroup` WHERE `ExportGroup`.`Export`=`Export`.`Id`) AS `GroupCount`, (SELECT COUNT(*) FROM `ExportUser` WHERE `ExportUser`.`Export`=`Export`.`Id`) AS `UserCount` FROM `Export` LEFT JOIN `User` ON `User`.`ID`=`Export`.`User` '.$Filter.$Order['SQL'].$PageList['SQLLimit']);
		while($Export = $DbResult->fetch_assoc())
		{
			$Action = '<a href="'.$this->System->Link('/export/?Action=View&amp;ExportId='.$Export['Id'].'&amp;Tab=0').'">Zobrazit</a> '.
  			'<a href="'.$this->System->Link('/export/?Action=View&amp;ExportId='.$Export['Id'].'&amp;Tab=7').'">Exportovat</a>';
			if($Export['User'] == $this->System->User->Id) $Action .= ' <a href="?Action=Delete&amp;ExportId='.$Export['Id'].'" onclick="return confirmAction(\'Opravdu smazat položku?\');">Smazat</a>';				
			$Output .= '<tr><td>'.HumanDate($Export['TimeCreate']).'</td>'.
				'<td>'.$Export['Title'].'</td>'.
				'<td>'.$Export['OutputType'].'</td>'.
				'<td>'.$Export['ClientVersion'].'</td>'.
				'<td>'.$Export['UsedCount'].'</td>'.
			  '<td>'.$Action.'</td></tr>';
		}
		$Output .= '</table>'.
				$PageList['Output'];
	
		$Output .= '<div style="text-align: center;"><a href="'.$this->System->Link('/export/').'">Stránka exportů</a></div>';
		return($Output);
	}
	
	function ShowLastTranslated()
  {
  	$Count = 20;
  	$Output = '<strong>Poslední překlady:</strong>';
  
  	$GroupListQuery = 'SELECT `Group`.* FROM `Group`';
  	$Query = '';
  	$UnionItems = array();
  	$DbResult = $this->Database->query($GroupListQuery);
  	if($DbResult->num_rows > 0)
  	{
  		while($DbRow = $DbResult->fetch_assoc())
  		{
  			$UnionItems[] = 'SELECT `T`.`ID`, `T`.`Take`, `T`.`User`, `T`.`ModifyTime`, `T`.`Group`, `T`.`GroupName` '.
  			  'FROM (SELECT `T`.`User`, `T`.`ID`, `T`.`ModifyTime`, '.
  				$DbRow['Id'].' AS `Group`, "'.addslashes($DbRow['Name']).'" AS `GroupName`, `T`.`Take` FROM `'.
  				$DbRow['TablePrefix'].'` AS `T` '.
  				'WHERE (`T`.`Complete` = 1) AND '.
  				'(`T`.`Language` != '.$this->System->Config['OriginalLanguage'].') AND '.
  				'(`T`.`User` = '.($_GET['user'] * 1).') ORDER BY `T`.`ModifyTime` DESC LIMIT '.
  				$Count.') AS `T`';
  		}
  		$Query = 'SELECT `TT`.*, `User`.`Name` AS `UserName`, `User`.`Id` AS `UserId` '.
  				'FROM ('.implode(' UNION ', $UnionItems).') AS `TT` '.
  				'JOIN `User` ON `User`.`Id` = `TT`.`User` '.
  				'ORDER BY `ModifyTime` DESC LIMIT '.$Count;
  		$DbResult = $this->Database->query($Query);
  		$Output .= '<table class="BaseTable"><tr>'.
  		  '<th>Datum</th><th>Nový</th><th>Zdroj</th><th>Skupina</th></tr>';
  		while($DbRow = $DbResult->fetch_assoc())
  		{
  			$Output .= '<tr><td>'.HumanDate($DbRow['ModifyTime']).'</td>'.  					
  					'<td><a href="form.php?group='.$DbRow['Group'].'&amp;ID='.$DbRow['ID'].'">'.$DbRow['ID'].'</a></td>'.
  					'<td><a href="form.php?group='.$DbRow['Group'].'&amp;ID='.$DbRow['Take'].'">'.$DbRow['Take'].'</a></td>'.
  					'<td><a href="TranslationList.php?group='.$DbRow['Group'].'&amp;action=filter">'.$DbRow['GroupName'].'</a></td></tr>';
  		}
  		$Output .= '</table>';
  	}
  	return($Output);
  }
		
	function ShowProfile()
	{
		$Output = '';
		$Query = 'SELECT `User`.`Name`, `UserTrace`.`LastLogin`, `UserTrace`.`LastIP`, '.
				'`User`.`Email`, `UserTrace`.`UserAgent`, '.
				'`User`.`TranslatedCount`, `User`.`Team`, `User`.`ID`, `User`.`Info`, '.
				'`Team`.`Name` AS `TeamName`, `Language`.`Name` AS `LanguageName`, '.
				'`ClientVersion`.`Version` AS `Version` FROM `User` '.
				'LEFT JOIN `UserTrace` ON `UserTrace`.`User` = `User`.`Id` '.
				'LEFT JOIN `Language` ON `Language`.`Id` = `User`.`Language` '.
				'LEFT JOIN `Team` ON `Team`.`Id` = `User`.`Team` '.
				'LEFT JOIN `ClientVersion` ON `ClientVersion`.`Id` = `User`.`PreferredVersion` '.
				'WHERE `User`.`Id` = '.($_GET['user'] * 1);
		$DbResult = $this->Database->query($Query);
		if($DbResult->num_rows > 0)
		{
		$UserLine = $DbResult->fetch_array();
		 
		$Output .=
		'<h3>Překladatel '.$UserLine['Name'].'</h3>'.
		'Výchozí jazyk: <strong>'.$UserLine['LanguageName'].'</strong><br />'.
		'Výchozí verze klienta: <strong>'.$UserLine['Version'].'</strong><br />'.
		'Poslední připojení: <strong>'.HumanDateTime($UserLine['LastLogin']).'</strong><br />'.
		'Počet přeložených: <a href="TranslationList.php?user='.$UserLine['ID'].'&amp;state=2&group=0" title="Zobrazit Všechny jeho přeložené texty"><strong>'.$UserLine['TranslatedCount'].'</strong></a><br />';
		if($UserLine['TeamName'] != '')
			$Output .= 'Člen týmu: <a href="team/?action=team&amp;id='.$UserLine['Team'].'"><strong>'.$UserLine['TeamName'].'</strong></a><br />';
		$Output .= '<fieldset><legend>Text profilu:</legend>'.str_replace("\n", '<br/>', $UserLine['Info']).'</fieldset><br/>';
	
  	$Output .= '<table class="Home"><tr>'.
  			'<td>'.$this->ShowLastTranslated().'</td>'.
  			'<td>'.$this->ExportList().'</td>'.
  			'</tr></table>';
		
		if($this->System->User->Licence(LICENCE_MODERATOR))
		{
			$Output .= '<fieldset><legend>Moderování</legend>';
			$Output .= 'Poslední IP: <strong>'.$UserLine['LastIP'].'</strong><br />'.
					'Prohlížeč: <strong>'.$UserLine['UserAgent'].'</strong><br />'.
					'Email: <strong>'.$UserLine['Email'].'</strong><br />';
			$Output .= '<br/><form action="user.php" method="post"><div>'.
					'Napsat E-mail:'.
					'<input type="text" name="email" value="'.$UserLine['Email'].'" /><br/>'.
					'Předmět:'.
					'<input type="text" name="subject" value="'.$this->System->Config['Web']['Title'].'" />'.
					'<br />'.
					'<textarea name="text" rows="20" cols="62">'.
					''."\n".
					'S pozdravem '.$this->System->User->Name."\n".
					'--------------------------------------------------------'."\n".
					$this->System->Config['Web']['Title'].' '.$this->System->Config['Web']['Host'].$this->System->Link('/')."\n".
					'</textarea><br/>'.
					'<input type="submit" value="Odeslat" />'.
					'</div></form></fieldset>';
		}
		} else $Output .= ShowMessage('Uživatel nenalezen', MESSAGE_CRITICAL);
		return($Output);
	}
	 
	function Show()
	{
		$Output = $this->SendMail();
		if(array_key_exists('user', $_GET))
		{
			$Output .= $this->ShowProfile();
		} else $Output .= ShowMessage('Nevybrán uživatel', MESSAGE_CRITICAL);
		return($Output);
	}	
}
